program gr_tab_config;

uses crt;

var
  f        : file of byte;
  fname    : string;
  port_str : string;
  lo_port  : byte;
  hi_port  : byte;
  port     : integer;
  irq      : byte;
  mask     : byte;

procedure get_config;
begin
  seek(f,$0cf);
  read(f,lo_port);
  read(f,hi_port);
  read(f,irq);
  read(f,mask);
end;

procedure show_config;
begin
    writeln('Konfigurationsprogramm fr den SoftTronix Grafiktablett-Maustreiber');
    writeln('');
    writeln;
    writeln;
    writeln('Die Treibersoftware fr das GT K6405 ist derzeit ',port_str,' konfiguriert.');
    writeln;
    writeln;
end;

procedure change_config;
var
  answer : char;
begin
  write('Mchten Sie diese Einstellung ndern ? (j/n) : ');
  repeat
    answer:=readkey;
  until (answer='j') or (answer='J') or (answer='n') or (answer='N');
  writeln(answer);
  if (answer='j') or (answer='J') then begin
    writeln;
    writeln('An welchen Port soll das Gert angeschlossen werden ?');
    writeln;
    writeln('        COM1:...........<1>');
    writeln('        COM2:...........<2>');
    writeln;
    write('Bitte geben Sie die gewnschte Zahl ein : ');
    repeat
      answer:=readkey;
    until (answer='1') or (answer='2');
    writeln(answer);
    case answer of
      '1' : begin
              lo_port:=$0f8;
              hi_port:=$3;
              irq:=$0c;
              mask:=$0ef;
              port_str:='COM1:';
            end;
      '2' : begin
              lo_port:=$0f8;
              hi_port:=$2;
              irq:=$0b;
              mask:=$0f7;
              port_str:='COM2:';
            end
    end;
    seek(f,$0cf);
    write(f,lo_port);
    write(f,hi_port);
    write(f,irq);
    write(f,mask);
    writeln;
    writeln('Die Software wurde fr den seriellen Port ',port_str,' konfiguriert !');
    writeln;
  end;
end;

begin
  clrscr;
  fname:='mouse!.com';
  assign(f,fname);
  {$i-}
    reset(f);
  {$i+}
  if ioresult=0 then begin
    get_config;
    port:=256*hi_port+lo_port;
    case port of
      $3f8 : port_str:='fr COM1:';
      $2f8 : port_str:='fr COM2:';
      else   port_str:='nicht';
    end;
    show_config;
    change_config;
  end
  else writeln('File nicht gefunden !');
end.